var express = require('express');
var app = express();
var multer = require('multer')
var upload = multer({ dest: 'public/uploads/' });
var fs = require('fs-extra');
var AWS = require('aws-sdk');

app.use(express.static('public'));

var rekognition = new AWS.Rekognition({ region: "us-east-1" });

app.post('/recognize', upload.single("image"), function(req, res, next) {
    var bitmap = fs.readFileSync(req.file.path);
    var params = {
        Image: {
            Bytes: bitmap
        },
        MinConfidence: 0.0
    };
    rekognition.detectModerationLabels(params, function(err, data) {
        if (err) {
            console.log(err, err.stack);
        } else {
            if (data.ModerationLabels[0]) {
                var result = {
                    image_path: req.file.path.replace('public', ''),
                    label: data.ModerationLabels[0].Name,
                    score: data.ModerationLabels[0].Confidence
                }
                res.json(result);
            } else {
                var result = { score: 0 , label: ""};
                res.json(result);
            }
        }
    });
});

app.listen(8000, function() {
    console.log('Listening on port 8000');
})